	rem =======================================
	rem ======== Pest Control in Space ========
	rem =======================================
	rem
	rem A game in Batari Basic by EffBee for
	rem                 Glorious Trainwrecks
	rem
	rem    http://www.glorioustrainwrecks.com/
	
	set kernel_options pfcolors no_blank_lines
	set romsize 8k

	rem == Definitions ==
	
	rem = Constants =
	
	const playfieldLeft = 10
	const playfieldRight = 130
	const playfieldTop = 10
	const playfieldBottom = 72
	const playfieldRightBullet = 150
	
	const pfscore=1
	
	rem = Variables =
	
	dim comb = a
	dim hivetop = b
	dim hivebottom = c
	dim hivecol = d
	dim selectside = e
	
	dim playerpfx = a
	dim playerpfy = b
	dim playerpfrightx = c
	dim playerpftopy = d
	dim playerpfbottomy = e
	
	dim ballpfx = a
	dim ballpfy = b
	
	dim beepfx = a
	dim beepfy = b
	
	dim beetimer = f
	dim beerow = g
	dim beerowAdvance = h
	dim beeflutter = a
	
	dim beerow0 = i
	dim beerow1 = j
	dim beerow2 = k
	dim beerow3 = l
	dim beerow4 = m
	dim beerow5 = n
	dim beerow6 = o
	dim beerow7 = p
	
	dim hiveRowsLeft = q
	
	dim beevelx = r
	dim beevely = s
	dim beeUpdate = h
	
	dim deadtimer = i
	dim deadorigx = j
	dim deadorigy = k
	dim deadtimeraccel = l
	dim deadoffset = m
	dim deadtimerUpdate = h
	
	dim shotsoundtime = t
	
	dim introscenetimer = b
	dim beejitter = c
	
	dim hiveThickness = x
	dim rowsCleared = y
	dim gameState = z
	
	rem = Builtins =
	
	pfscorecolor = $0C
	scorecolor = $0C
	
end

gameOver
	
	pfclear
	
	player0x = 50
	player0y = 50
	player1x = 120
	player1y = 30
	ballx = 200
	bally = 100
	missile1x = 200
	missile1y = 100
	
	beetimer = 0
	rem Bee sprite should face left...
	beevelx = 120
	
	playfield:
	...XXX..XXX..XXX.XXXXX..........
	...X.XX.X...X......X............
	...XXX..XX...XX....X............
	...X....X......X...X............
	...X....XXX.XXX....X............
	................................
	.XX..XX..X..X.XXXXX.XXX..XX..X..
	X...X..X.XX.X...X...X.X.X..X.X..
	X...X..X.X.XX...X...XX..X..X.X..
	X...X..X.X..X...X...X.X.X..X.X..
	.XX..XX..X..X...X...X.X..XX..XXX
end
	
	introscenetimer = 0
	
gameOverLoop
	
	pfcolors:
	$1A
	$12
	$1A
	$12
	$1A
	$12
	$4C
	$4C
	$4A
	$48
	$46
	$44
end
	
	COLUBK = $00
	
	beetimer = beetimer + 1
	gosub beeSpriteNorm
	gosub smallBeeSprite
	
	beejitter = rand
	if beejitter{0} then player0x = player0x + 1 else player0x = player0x - 1
	if beejitter{1} then player0y = player0y + 1 else player0y = player0y - 1
	if beejitter{2} then player1x = player1x + 1 else player1x = player1x - 1
	if beejitter{3} then player1y = player1y + 1 else player1y = player1y - 1
	
	if introscenetimer < 30 then introscenetimer = introscenetimer + 1
	if joy0fire && introscenetimer > 29 then goto newGame
	
	drawscreen
	
	goto gameOverLoop

newGame
	score = 0
	hiveThickness = 30
	pfscore1 = %00000101
	
	beetimer = 0
	introscenetimer = 0
	
	rem So that they face right in the intro
	beevelx = 130
	
	player0y = 100
	player1y = 100
	
	AUDC0 = 1
	AUDV0 = 15
	AUDF0 = 0
	AUDC1 = 14
	AUDV1 = 9
	
	pfclear
	
introSceneLoop
	
	beetimer = beetimer + 1
	
	player0x = player0x + 10
	player1x = player1x + 20
	
	beeUpdate = beetimer - (beetimer / 16 * 16)
	if beeUpdate = 0 && introscenetimer < 8 then player0x = 0 : player0y = (rand / 4) + 20 : introscenetimer = introscenetimer + 1
	AUDF0 = beeUpdate
	beeUpdate = beetimer - (beetimer / 8 * 8)
	if beeUpdate = 7 && introscenetimer < 8 then player1x = 0 : player1y = (rand / 4) + 20
	
	if introscenetimer > 7 then AUDV0 = 0
	
	if player0x > 150 then player0y = 100
	if player1x > 150 then player1y = 100
	
	gosub smallBeeSprite
	gosub beeSpriteNorm
	gosub beeBuzz
	
	drawscreen
	
	if introscenetimer < 8 || player0y <> 100 then goto introSceneLoop
	
	player0y = 100
	
	AUDC1 = 15
	AUDF1 = 19
	
	for introscenetimer = 0 to 220 step 2
	
	gosub shipSprite
	
	if introscenetimer > 60 then player0y = 50
	player0x = introscenetimer - 60
	
	drawscreen
	
	next
	
	player0y = 100
	
	goto newLevel

resumeLevel
	gosub resetLevelState
	goto computeAllBeeSpawns

resetLevelState
	COLUBK = $00
	AUDV1 = 0
	
	player0x = (playfieldLeft + playfieldRight) / 8
	player0y = (playfieldTop + playfieldBottom) / 2
	player1x = 200
	player1y = 100
	
	rem bullet fired
	gameState{0} = 0
	
	rem bee visible
	gameState{1} = 0
	
	rem ship killed
	gameState{2} = 0
	
	rem bee dying
	gameState{3} = 0
	
	rem bee venom visible
	gameState{4} = 0
	
	ballx = 200
	bally = 100
	
	missile1x = 200
	missile1y = 100
	
	beetimer = 0
	beerow = 0

	return

newLevel
	
	pfclear
	
	gosub resetLevelState
	
	hiveRowsLeft = 8
	if hiveThickness > 20 then hiveThickness = hiveThickness - 1

buildHiveStart
	rowsCleared = 0
	hivetop = 1
	hivebottom = 8
	hivecol = 31
	
	AUDV0 = 0
	AUDV1 = 6
	AUDC1 = 3
	AUDF1 = 31

buildHiveLoop

	pfcolors:
	$28
	$24
	$2A
	$28
	$26
	$2A
	$28
	$2A
	$26
	$24
	$28
	$26
end

	for comb = hivetop to hivebottom step 1
	pfpixel hivecol comb on
	next
	
	AUDF1 = hivecol
	
	hivecol = hivecol - 1
	selectside = (rand & 1)
	if hivecol < hiveThickness then gosub shrinkHiveSides
	
	drawscreen
	
	if hivebottom > hivetop then goto buildHiveLoop
	
	AUDV1 = 0

computeAllBeeSpawns
	
	rem Computer bee spawns
	rem Wishing I had arrays...
	
	beepfy = 0
	
	gosub computeBeeSpawn
	beerow0 = beepfx
	gosub computeBeeSpawn
	beerow1 = beepfx
	gosub computeBeeSpawn
	beerow2 = beepfx
	gosub computeBeeSpawn
	beerow3 = beepfx
	gosub computeBeeSpawn
	beerow4 = beepfx
	gosub computeBeeSpawn
	beerow5 = beepfx
	gosub computeBeeSpawn
	beerow6 = beepfx
	gosub computeBeeSpawn
	beerow7 = beepfx
	
	drawscreen
	
	goto gameLoop

shrinkHiveSides
	if selectside = 1 then hivetop = hivetop + 1 else hivebottom = hivebottom - 1
	return

computeBeeSpawn
	
	beepfx = 32
	beepfy = beepfy + 1
	
	for beerowAdvance = 0 to 10 step 1
	beepfx = beepfx - 2
	if pfread(beepfx,beepfy) then next
	
	return

gameLoop
	
	if !gameState{2} then goto mainGame else goto deadShip
	
deadShip
	
	COLUBK = $2A
	deadtimer = 0
	
	AUDV0 = 15
	AUDV1 = 0
	AUDC0 = 8
	AUDF0 = 4
	AUDC1 = 0
	
	deadorigx = player0x - 4
	deadorigy = player0y
	deadtimeraccel = 0
	deadoffset = 0
	
	ballx = deadorigx + 10
	bally = deadorigy - 2
	ballheight = 1
	CTRLPF = $01
	
deadShipLoop
	
	COLUP0 = $0E
	COLUP1 = $0E
	
	pfcolors:
	$0E
	$0E
	$0E
	$0E
	$0E
	$0E
	$0E
	$0E
	$0E
	$0E
	$0E
	$0E
end
	
	player0:
	%01000
	%00111
	%10010
	%00110
	%01111
	%11010
	%00000
	%00100
end
	
	player1:
	%00010
	%00000
	%01101
	%01100
	%10110
	%00011
	%00010
end
	
	deadtimer = deadtimer + 1
	
	if deadtimer = 40 then ballheight = 2 : CTRLPF = $11
	if deadtimer = 70 then ballheight = 4 : CTRLPF = $21 : ballx = ballx - 1 : bally = bally + 1
	if deadtimer = 100 then ballheight = 8 : CTRLPF = $31 : ballx = ballx - 2 : bally = bally + 2
	
	if deadtimer < 108 then AUDF0 = (deadtimer / 4) + 4
	deadtimerUpdate = deadtimer / 16 * 16
	if deadtimer > 80 && deadtimerUpdate = deadtimer then deadtimeraccel = deadtimeraccel + 1
	if deadtimer < 80 && deadtimerUpdate = deadtimer then deadoffset = deadoffset + 1
	deadoffset = deadoffset + deadtimeraccel
	
	player0x = deadorigx - (deadoffset / 2)
	player1x = deadorigx + 8 + (deadoffset / 2)
	player1y = deadorigy - (deadoffset / 4)
	
	rem Hide sprite position wraparound artifact
	if player0x > 200 then player0y = 100
	
	drawscreen
	
	if deadtimer < 120 then goto deadShipLoop
	
	AUDV0 = 0
	AUDC0 = 0
	
	rem Out of lives?
	
	if pfscore1 = 0 then goto gameOver
	
	rem Subtract a life...
	
	pfscore1 = pfscore1 / 4
	
	goto resumeLevel
	
mainGame
	
	ballheight = 0
	CTRLPF = $21
	missile1height = 0
	NUSIZ1 = $20
	
	AUDC1 = 14
	
	pfcolors:
	$28
	$24
	$2A
	$28
	$26
	$2A
	$28
	$2A
	$26
	$24
	$28
	$26
end
	
	gosub shipSprite
	
	rem Used for collision with hive
	
	playerpfx = (player0x - 10) / 4
	playerpfy = (player0y - 2) / 8
	playerpfrightx = (player0x - 9) / 4
	playerpftopy = (player0y - 3) / 8
	playerpfbottomy = (player0y - 1) / 8
	
	rem Player movement
	
	if joy0left then player0x = player0x - 1
	if joy0right && !pfread(playerpfrightx,playerpfy) then player0x = player0x + 1
	if joy0up && !pfread(playerpfx,playerpftopy) then player0y = player0y - 1
	if joy0down && !pfread(playerpfx,playerpfbottomy) then player0y = player0y + 1
	
	rem Player bounds
	
	if player0x > playfieldRight then player0x = playfieldRight
	if player0x < playfieldLeft then player0x = playfieldLeft
	if player0y > playfieldBottom then player0y = playfieldBottom
	if player0y < playfieldTop then player0y = playfieldTop
	
	rem Fire bullet
	
	if joy0fire && !gameState{0} then gosub fireBullet
	if gameState{0} then gosub moveBullet
	
	rem BEES ARE COMIIIIIIIIIIIIIIIINGG WOOOOOOO!!
	
	beetimer = beetimer + 1
	gosub chooseBeeRow
	
	if !gameState{1} && beetimer > 60 then gosub spawnBee
	if gameState{1} && !gameState{3} then gosub moveBee : AUDV1 = 6
	
	rem Buzz buzz buzz...
	
	gosub beeBuzz
	
	rem Bzzr...
	
	if gameState{3} then gosub killBee : gosub beeSpriteOw else gosub beeSpriteNorm
	if gameState{4} then gosub moveVenom
	
	rem = Did we win the level? =
	
	if rowsCleared = 255 && !gameState{1} && !gameState{2} && !gameState{4} then score = score + 1000 : goto newLevel
	
	drawscreen
	
	goto gameLoop

fireBullet
	ballx = player0x + 5
	bally = player0y - 2
	gameState{0} = 1
	
	shotsoundtime = 0

	return

moveBullet
	
	if shotsoundtime < 20 then shotsoundtime = shotsoundtime + 1 : AUDV0 = 7 else AUDV0 = 0
	AUDC0 = 12
	AUDF0 = shotsoundtime
	
	ballx = ballx + 4
	
	if ballx > playfieldRightBullet then gosub killBullet : return
	
	ballpfx = (ballx - 18) / 4
	ballpfy = (bally) / 8
	
	rem Hit a bee?
	
	if gameState{1} && collision(ball,player1) then gameState{3} = 1 : gosub killBullet
	
	rem Hit a comb?
	
	if pfread(ballpfx,ballpfy) then pfpixel ballpfx ballpfy off : score = score + 1 : gosub killBullet : gosub updateHiveRow
	
	return

killBullet
	ballx = 200
	bally = 100
	gameState{0} = 0
	
	shotsoundtime = 0
	AUDV0 = 0
	
	return

fireVenom
	missile1x = player1x
	missile1y = player1y - 3
	gameState{4} = 1
	
	return

moveVenom
	
	missile1x = missile1x - 2
	
	if missile1x < playfieldLeft then gosub killVenom : return
	
	rem Hit player?
	
	if collision(missile1,player0) then gameState{3} = 1 : gosub killVenom : gameState{2} = 1
	
	return

killVenom

	missile1x = 200
	missile1y = 100
	gameState{4} = 0
	
	return

updateHiveRow
	if ballpfx <> 31 then gosub updateBeeSpawn else gosub clearRow
	return

updateBeeSpawn

	rem meh. Variables can't be used in bit access so I have to compare to each value by hand
	
	if ballpfy = 1 then beerow0 = ballpfx : return
	if ballpfy = 2 then beerow1 = ballpfx : return
	if ballpfy = 3 then beerow2 = ballpfx : return
	if ballpfy = 4 then beerow3 = ballpfx : return
	if ballpfy = 5 then beerow4 = ballpfx : return
	if ballpfy = 6 then beerow5 = ballpfx : return
	if ballpfy = 7 then beerow6 = ballpfx : return
	if ballpfy = 8 then beerow7 = ballpfx : return

clearRow
	if ballpfx <> 31 then return
	
	hiveRowsLeft = hiveRowsLeft - 1
	
	rem meh. Variables can't be used in bit access so I have to compare to each value by hand
	
	if ballpfy = 1 then rowsCleared{0} = 1 : return
	if ballpfy = 2 then rowsCleared{1} = 1 : return
	if ballpfy = 3 then rowsCleared{2} = 1 : return
	if ballpfy = 4 then rowsCleared{3} = 1 : return
	if ballpfy = 5 then rowsCleared{4} = 1 : return
	if ballpfy = 6 then rowsCleared{5} = 1 : return
	if ballpfy = 7 then rowsCleared{6} = 1 : return
	if ballpfy = 8 then rowsCleared{7} = 1 : return
	
	return

chooseBeeRow
	if hiveRowsLeft > 4 then beerowAdvance = (rand & 3) + 1 else beerowAdvance = (rand & 1) + 1
	beerow = beerow + beerowAdvance
	if beerow > 7 then beerow = beerow - 8
	
	rem Sanity check... otherwise we loop forever
	
	if rowsCleared = 255 then return
	
beeRowWraparound
	
	rem Grr, I really wish I could use variables in bit access!
	
	if beerow = 0 && rowsCleared{0} then beerow = 1
	if beerow = 1 && rowsCleared{1} then beerow = 2
	if beerow = 2 && rowsCleared{2} then beerow = 3
	if beerow = 3 && rowsCleared{3} then beerow = 4
	if beerow = 4 && rowsCleared{4} then beerow = 5
	if beerow = 5 && rowsCleared{5} then beerow = 6
	if beerow = 6 && rowsCleared{6} then beerow = 7
	if beerow = 7 && rowsCleared{7} then beerow = 0
	if beerow = 0 && rowsCleared{0} then goto beeRowWraparound

	return

spawnBee
	beepfx = 32
	
	rem Where are my arrays
	
	if beerow = 0 then beepfx = beerow0
	if beerow = 1 then beepfx = beerow1
	if beerow = 2 then beepfx = beerow2
	if beerow = 3 then beepfx = beerow3
	if beerow = 4 then beepfx = beerow4
	if beerow = 5 then beepfx = beerow5
	if beerow = 6 then beepfx = beerow6
	if beerow = 7 then beepfx = beerow7
	
	player1x = beepfx * 4 + 16
	player1y = (beerow + 1) * 8 + 8
	
	beevelx = 127
	beevely = 127
	gameState{1} = 1
	
	return

moveBee
	
	beeUpdate = (rand & 7)
	if beeUpdate = 0 then gosub updateBeeVel
	
	rem Reusing variable for positional update...
	rem Super evil megafast bees when the player gets far enough
	if hiveThickness > 22 then beeUpdate = beetimer - (beetimer / 2 * 2) else beeUpdate = 0
	if player0x < player1x && beevelx > 126 then beevelx = beevelx - 1
	if beeUpdate = 0 then player1x = player1x + (beevelx - 127) : player1y = player1y + (beevely - 127)
	
	rem Bee bounds
	
	if player1x > playfieldRight then player1x = playfieldRight : beevelx = 126
	if player1x < playfieldLeft then player1x = playfieldLeft : beevelx = 128
	if player1y > playfieldBottom then player1y = playfieldBottom : beevely = 126
	if player1y < playfieldTop then player1y = playfieldTop : beevely = 128
	
	beeUpdate = 1
	if hiveThickness < 28 && hiveThickness > 25 then beeUpdate = beetimer - (beetimer / 128 * 128) - 96
	if hiveThickness < 26 then beeUpdate = beetimer - (beetimer / 64 * 64)
	if beeUpdate = 0 && beevelx < 128 && !gameState{4} then gosub fireVenom
	
	if collision(player0,player1) then gameState{2} = 1
	
	return

updateBeeVel
	if player0x > player1x && beevelx < 130 then beevelx = beevelx + 1
	if player0y > player1y && beevely < 130 then beevely = beevely + 1
	if player0y < player1y && beevely > 124 then beevely = beevely - 1
	return

beeBuzz
	beeflutter = beetimer - (beetimer / 4 * 4)
	AUDF1 = 6 + beeflutter
	
	return

killBee
	
	AUDV1 = 13
	AUDF1 = player1y / 8
	
	if beevely < 132 then beevely = beevely + 1
	
	player1x = player1x + (beevelx - 127)
	player1y = player1y + (beevely - 127)
	
	if player1y < 100 then return
	
	player1x = 200
	player1y = 100
	gameState{1} = 0
	gameState{3} = 0
	beetimer = (rand & 7)
	
	AUDV1 = 0
	
	return

shipSprite
	
	COLUP0 = $0A
	
	player0:
	%1110000
	%0011111
	%0011100
	%0111000
	%1100000
	%0000000
end
	
	return
	
smallBeeSprite
	COLUP0 = $1E
	
	player0:
	%0001
	%0110
	%1110
	%0011
end
	
	return

beeSpriteNorm
	
	COLUP1 = $1E
	
	beeUpdate = beetimer - (beetimer / 2 * 2)
	if beevelx > 127 then REFP1 = 8 else REFP1 = 0
	if beeUpdate = 1 then goto beeSpriteNorm2
	
beeSpriteNorm1
	
	player1:
	%11100000
	%01111100
	%00101110
	%00011010
	%00001110
	%01111101
	%01111010
	%10010010
end
	
	return
	
beeSpriteNorm2
	
	player1:
	%11100000
	%01111100
	%00101110
	%00011010
	%00001110
	%01111100
	%01111000
	%10010000
end
	
	return

beeSpriteOw
	
	COLUP1 = $1E
	
	player1:
	%00111100
	%00111100
	%00011001
	%00011000
	%00100100
	%10011100
	%00001010
	%01000111
end
	
	return
